VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.UserControl Chat 
   ClientHeight    =   1125
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1095
   ScaleHeight     =   1125
   ScaleWidth      =   1095
   Begin VB.Timer tKeepAlive 
      Interval        =   65000
      Left            =   600
      Top             =   120
   End
   Begin VB.Timer tMessageRate 
      Enabled         =   0   'False
      Interval        =   16000
      Left            =   120
      Top             =   600
   End
   Begin VB.Timer tPacketRate 
      Enabled         =   0   'False
      Interval        =   60000
      Left            =   600
      Top             =   600
   End
   Begin MSWinsockLib.Winsock wskChat 
      Left            =   120
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "Chat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Authorizing As Boolean 'if this is the ChatNav socket
Public ChatCookie As String 'authorization cookie

Private AuthLeave As Boolean 'if you're leaving the chat

Public InChat As Boolean 'if you're in the chat
Public ChatServer As String 'server of the chat
Public ChatIndex As Integer 'socket index
Public Chatname As String 'name of chat
Public Exchange As Integer 'exchange of chat
Public Instance As Integer 'instance of chat

Private PacketRated As Boolean 'if you are packet rated
Private MessageRated As Boolean 'if you are chat message rated

Public Owner As Boolean 'if you own the chat

Private SNACID As Integer
Private Bans As New Collection
Private Unbans As New Collection

Public Event JoinedChat(Chatname As String, Exchange As Integer, Instance As Integer)
Public Event RoomOwner(Screenname As String)
Public Event ChatUserJoined(Screenname As String)
Public Event ChatUserLeft(Screenname As String)
Public Event ChatMessage(Screenname As String, Message As String)
Public Event Ban(Screenname As String, Successful As Boolean)
Public Event Unban(Screenname As String, Successful As Boolean)
Public Event ClosedChat(Successful As Boolean)
Public Event LeftChat(KickedOut As Boolean)
Public Event PacketRated()
Public Event MessageRated()
Public Event ChatRated()

Public Event HostReady(ChatNav As Boolean)
Public Event ChatNavError(Errorcode As Integer)

Public Sub ConnectToServer(ChatServer As String)
wskChat.Close
wskChat.RemoteHost = ChatServer
wskChat.RemotePort = 5190
wskChat.Connect
End Sub

Public Sub BanUser(Screenname As String)
    
    SNACID = SNACID + 1
    
    If SNACID > 100 Then SNACID = 0
    
    SendChat 2, ChrA("0 14 0 36 0 0 " & SNACID & " 0 0 36") & Chr$(Len(Screenname)) & Screenname
    
    Bans.Add Chr$(SNACID) & Screenname

End Sub

Public Sub UnbanUser(Screenname As String)

    SNACID = SNACID + 1

    If SNACID > 100 Then SNACID = 0

    SendChat 2, ChrA("0 14 0 37 0 0 " & SNACID & " 0 0 37") & Chr$(Len(Screenname)) & Screenname

    Unbans.Add Chr$(SNACID) & Screenname

End Sub

Public Sub CloseChat()
    
    SendChat 2, ChrA("0 14 0 35 0 0 0 0 0 35")

End Sub

Public Sub SendMessage(Message As String, Reflection As Boolean)
If MessageRated = True Then Exit Sub
If Reflection = True Then
    SendChat 2, ChrA("0 14 0 5 0 0 0 0 0 5") & ReqID2 & ChrA("0 3") & TLV(1, vbNullString) & TLV(6, vbNullString) & TLV(5, TLV(2, "us-ascii") & TLV(3, "en") & TLV(1, Message))
                                                         'channel     'public(1)/whisper(2)     'receive own msgs           'encoding             'language      'message
ElseIf Reflection = False Then
    SendChat 2, ChrA("0 14 0 5 0 0 0 0 0 5") & ReqID2 & ChrA("0 3") & TLV(1, vbNullString) & TLV(5, TLV(2, "us-ascii") & TLV(3, "en") & TLV(1, Message))
                                                         'channel     'public(1)/whisper(2)           'encoding             'language      'message
End If
'whispering is dead
End Sub

Private Sub GotData(ByRef strData As String)
If Len(strData) = 0 Then Exit Sub
Select Case AscW%(Mid$(strData, 2, 1))
    Case 1 'connection
        SendChat 1, ChrA("0 0 0 1") & TLV(6, ChatCookie)
    Case 2 'main data channel
        If InChat Then
            ParseChatEvents strData
        Else
            ParseChatJoin strData
        End If
    Case 4 'disconnected
        LeaveChat True
End Select
End Sub

Private Sub ParseChatJoin(strData As String)
Select Case Asc%(Mid$(strData, 8, 1)) & Asc%(Mid$(strData, 10, 1))
    Case 13 '1 x 3 (host ready)
        If Authorizing = True Then
            SendChat 2, ChatNavReady 'completes connection with chat navigation server
            RaiseEvent HostReady(True)
        Else
            'ghosting here (you can send chat messages)
            SendChat 2, ChatReady 'joins the chat
            InChat = True
            RaiseEvent HostReady(False)
        End If
        
    Case 131 '13 x 1 (ChatNav error)
        Select Case Asc%(Right$(strData, 1))
            Case 54 'chat rated
                RaiseEvent ChatRated
            Case Else 'other error
                RaiseEvent ChatNavError(Asc%(Right$(strData, 1)))
        End Select
        Authorizing = False
        LeaveChat
End Select
End Sub

Private Sub ParseChatEvents(strData As String)
Dim TotalNumber As Long, RateClassID As Long, Window As Long, Clear As Long, Alert As Long, Limit As Long, Disconnect As Long, Current As Long, Max As Long
Dim Screenname As String, Length As String, TLVcount As Integer, tmptlvpointer As Integer, tmptlvlength  As Integer
Dim i As Integer, ii As Integer
Select Case Asc%(Mid$(strData, 10, 1))
    Case 1 'ban result / error (14 x 1)
        Select Case Asc%(Mid$(strData, 16, 1)) 'last byte of SNAC request ID
            Case 35 'chat close
                If Asc%(Mid$(strData, 18, 1)) = 13 Then 'error
                    Select Case Asc%(Mid$(strData, 24, 1)) 'error code
                        Case 72 'not owner
                            Owner = False
                    End Select
                    RaiseEvent ClosedChat(False)
                Else 'no error
                    RaiseEvent ClosedChat(True)
                End If
            Case 36 'ban
                For i = 1 To Bans.Count 'chr$(snacid) & screenname)
                    If Mid$(Bans(i), 1, 1) = Mid$(strData, 13, 1) Then 'find first byte of SNAC request ID
                        If Asc%(Mid$(strData, 18, 1)) = 13 Then 'error
                            Select Case Asc%(Mid$(strData, 24, 1)) 'error code
                                Case 72 'not owner
                                    Owner = False
                                Case 25 'user not in room
                                    
                            End Select
                            RaiseEvent Ban(Mid$(Bans(i), 2), False)
                        Else 'no error
                            RaiseEvent Ban(Mid$(Bans(i), 2), True)
                        End If
                        Bans.Remove i
                        Exit For
                    End If
                Next i
            Case 37 'unban
                For i = 1 To Unbans.Count 'chr$(snacid) & screenname
                    If Mid$(Unbans(i), 1, 1) = Mid$(strData, 13, 1) Then 'find first byte of SNAC request ID
                        If Asc%(Mid$(strData, 18, 1)) = 13 Then 'error
                            Select Case Asc%(Mid$(strData, 24, 1)) 'error code
                                Case 72 'not owner
                                    Owner = False
                                Case 25 'user not in room
                                    
                            End Select
                            RaiseEvent Unban(Mid$(Unbans(i), 2), False)
                        Else 'no error
                            RaiseEvent Unban(Mid$(Unbans(i), 2), True)
                        End If
                        Unbans.Remove i
                        Exit For
                    End If
                Next i
        End Select
            
    Case 2 'chat room information (14 x 2)
        
    Case 3 'users joined (14 x 3)
        i = 17
        Do Until i >= Len(strData)
            Length = Asc%(Mid$(strData, i, 1)) 'length of screenname
            i = i + 1
            Screenname = Mid$(strData, i, Length) 'screenname
            If Not Strip(Screenname) = vbNullString Then 'if we got a screenname, raise event
                RaiseEvent ChatUserJoined(Screenname)
            End If
            i = i + Length + 2 'skip warning level
            TLVcount = GetWord(Mid$(strData, i, 2)) 'get number of TLVs
            i = i + 2
            tmptlvpointer = 1
            Do Until tmptlvpointer > TLVcount
                i = i + 2
                tmptlvlength = GetWord(Mid(strData, i, 2))
                i = i + 2
                i = i + tmptlvlength
                tmptlvpointer = tmptlvpointer + 1
            Loop
        Loop


    Case 4 'users left (14 x 4)
        i = 17
        Do Until i > Len(strData)
            Length = Asc%(Mid$(strData, i, 1)) 'length of screenname
            Screenname = Mid$(strData, i + 1, Length) 'screenname
            If Not Strip(Screenname) = vbNullString Then 'if we got a screenname, raise event
                RaiseEvent ChatUserLeft(Screenname)
            End If
            i = i + Length + 2 'skip warning level
            TLVcount = GetWord(Mid$(strData, i, 2)) 'get number of TLVs
            For ii = 1 To TLVcount 'skip other TLVs
                i = i + 8
            Next ii
        Loop
        
    Case 6 'incoming chat message (14 x 6)
        If InStr(strData, "FROM_AOL") Then Exit Sub 'OnlineHost
        Length = Asc%(Mid$(strData, 31, 1))
        Screenname = Mid$(strData, 32, Length)
        Dim Message As String
        If InStr(strData, "<HTML>") <> 0 Then
            Message = Mid$(strData, InStr(strData, "<HTML>"))
        Else
            Message = "[Text could not be displayed.]" 'error code/symbol
        End If
        RaiseEvent ChatMessage(Screenname, Message)
        
    Case 7 'request rate information (1 x 7)(response to RequestRateInformation, 1 x 6)
        TotalNumber = Asc%(Mid$(strData, 18, 1)) 'total number of rate limits
        i = 19
        For ii = 1 To TotalNumber
            RateClassID = GetWord(Mid$(strData, i, 2)) 'rate class ID
            i = i + 4
            Window = GetWord(Mid$(strData, i, 2)) 'window size
            i = i + 4
            Clear = GetWord(Mid$(strData, i, 2)) 'clear level
            i = i + 4
            Alert = GetWord(Mid$(strData, i, 2)) 'alert level
            i = i + 4
            Limit = GetWord(Mid$(strData, i, 2)) 'limit level
            i = i + 4
            Disconnect = GetWord(Mid$(strData, i, 2)) 'disconnect level
            i = i + 4
            Current = GetWord(Mid$(strData, i, 2)) 'current level
            i = i + 4
            Max = GetWord(Mid$(strData, i, 2)) 'max level
            i = i + 7
        Next ii
        
        'rate class 1 = packet rate (including ban rating)
        'window size = 80
        'clear level = 2500
        'alert level = 2000
        'limit level = 1500
        'disconnect level = 800
        'max level = 6000
        '(goes down every time packet is sent, except for chat messages)
        
        'rate class 5 = message rate
        'window size = 10
        'clear level = 5500
        'alert level = 5300
        'limit level = 4200
        'disconnect level = 3000
        'max level = 8000

    Case 10 'rate (1 x 10)
        RateClassID = GetWord(Mid$(strData, 29, 2)) 'rate class ID
        Window = GetWord(Mid$(strData, 33, 2)) 'window size
        Clear = GetWord(Mid$(strData, 37, 2)) 'clear level
        Alert = GetWord(Mid$(strData, 41, 2)) 'alert level
        Limit = GetWord(Mid$(strData, 45, 2)) 'limit level
        Disconnect = GetWord(Mid$(strData, 49, 2)) 'disconnect level
        Current = GetWord(Mid$(strData, 53, 2)) 'current level
        Max = GetWord(Mid$(strData, 57, 2)) 'max level
        If RateClassID = 5 Then 'message rated
            If Asc%(Right$(strData, 1)) = 0 Then 'warning
                
            ElseIf Asc%(Right$(strData, 1)) = 1 Then 'rated
                MessageRate 'takes 16 seconds to unrate
            End If
        ElseIf RateClassID = 1 Then 'packet rated
            If Asc%(Right$(strData, 1)) = 0 Then 'warning
                
            ElseIf Asc%(Right$(strData, 1)) = 1 Then 'rated
                PacketRate 'takes 1 minute to unrate
            End If
        End If
        
    Case 34 'CLIENT_EVENT (14 x 34)
        'sent for AIM6+ users (typing status)
        
    Case 38 'UPDATE_PREFERENCES (14 x 38)
        RaiseEvent JoinedChat(Chatname, Exchange, Instance)
        
    Case 48 'SET_ROOM_OWNER (14 x 48)
        Screenname = Mid$(strData, 18, Asc%(Mid$(strData, 17, 1)))
        RaiseEvent RoomOwner(Screenname)
End Select
End Sub

Public Sub LeaveChat(Optional KickedOut As Boolean = False)
If Authorizing = True Then Exit Sub
AuthLeave = True
SendChat 4, vbNullString '"graceful" disconnect
wskChat.Close
RaiseEvent LeftChat(KickedOut)
End Sub

Private Sub MessageRate()
MessageRated = True
tMessageRate.Enabled = True
RaiseEvent MessageRated
End Sub

Private Sub PacketRate()
PacketRated = True
tPacketRate.Enabled = True
RaiseEvent PacketRated
End Sub

Private Sub tPacketRate_Timer()
PacketRated = False
End Sub

Private Sub tKeepAlive_Timer() 'KeepAlive
If wskChat.State = sckConnected Then SendChat 5, vbNullString
End Sub

Private Sub tMessageRate_Timer()
MessageRated = False
End Sub

Private Sub SendChat(Channel As Long, ByRef strData As String)
Static ReqID As Long 'request ID (packet counter or w/e you wanna call it)
If wskChat.State <> sckConnected Then
    If AuthLeave = False Then LeaveChat
    AuthLeave = False
    Exit Sub
End If
wskChat.SendData "*" & Chr$(Channel) & Word(ReqID) & Word(Len(strData)) & strData
ReqID = ReqID + 1
If ReqID > 65535 Then ReqID = 0
End Sub

Private Sub wskChat_Close()
LeaveChat
End Sub

Private Sub wskChat_DataArrival(ByVal bytesTotal As Long)
Static Buffer As String
Dim NewData As String, Length As Long
If wskChat.State <> sckConnected Then LeaveChat: Exit Sub
wskChat.GetData NewData, vbString, bytesTotal 'get new data
Buffer = Buffer & NewData 'add data to buffer
Do While Len(Buffer) >= Length
    Length = GetWord(Mid$(Buffer, 5, 2)) + 6 'get length of packet
    If Len(Buffer) >= Length Then 'if the packet is in the data
        Call GotData(Mid$(Buffer, 1, Length)) 'parse packet
        Buffer = Mid$(Buffer, Length + 1) 'remove packet from buffer
    Else
        Exit Sub
    End If
Loop
End Sub
